#include <stdio.h>
#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>


#define F_OSC 16000000
#define UART_BAUD_RATE 57600
#define UART_BAUD_CALC(UART_BAUD_RATE,F_OSC) ((F_OSC)/((UART_BAUD_RATE)*16L)-1)

int uart_putchar (char c){
	if (c == '\n')uart_putchar('\r');	// damn M$
	while (!(UCSRA & (1 << UDRE)));		// Wait until ready for sending
	UDR = c;				// Send char
	return (0);				// return 0
}

void uart_init(void){
	UCSRB |= (1<<TXEN)|(1<<RXEN)|(1<<RXCIE);	// Enable Txd Rxd and RXCIE for complete receving
	UCSRC |= (1<<URSEL)|(3<<UCSZ0);			// Set 8 bits and 1 Stopbit
	UBRRH=(uint8_t)(UART_BAUD_CALC(UART_BAUD_RATE,F_OSC)>>8); // Set baudrate
	UBRRL=(uint8_t)UART_BAUD_CALC(UART_BAUD_RATE,F_OSC);
	fdevopen (uart_putchar, NULL, 0);	//printf for uart_putchar
}
