#include <stdio.h>
#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>
#include "lib/matrix.h"
#include "lib/uart.h"

uint8_t z,s,t;
uint8_t temp;
uint8_t o;
unsigned char in;

void convert(void);
void clean_matrix(void);
void uart_string(const char *s);

void uart_string(const char *s){
	while(*s)
		uart_putchar(*s++);
}

void convert(void){
	temp=0;
	if (in == 'c'){clean_matrix();o=0;}
	if (in == 'r'){uart_string("r");z=0;t=0;s=0;o=0;}
	if (in == '1'){temp=1;};
	if (in == '2'){temp=2;};
	if (in == '3'){temp=3;};
	if (in == '4'){temp=4;};
	if (in == '5'){temp=5;};
	if (in == '6'){temp=6;};
	if (in == '7'){temp=7;};
	if (in == '8'){temp=8;};
	if (in == '9'){temp=9;};
	if (in == '0'){temp=0;};
}

SIGNAL(SIG_UART_RECV){
	if (UCSRA&(1<<DOR)){uart_putchar('!');};
	in = UDR;
	convert();
	if(o == 1){
		z=(temp*10);
		uart_string("k");
		temp=0;
	}
	if(o == 2){
		z=z+temp;
		uart_string("k");
		temp=0;
	}
	if(o == 3){
		t=temp;
		uart_string("k");
		temp=0;
	}
	if(o == 4){
		s=(temp*100);
		uart_string("k");
		temp=0;
	}
	if(o == 5){
		s=s+(temp*10);
		uart_string("k");
		temp=0;
	}
	if(o == 6){
		s=s+temp;
		uart_string("k");
		zeilen[z][t]=s;
		temp=0;
		z=0;t=0;s=0;
		o=0;
	}
	o++;
}

void clean_matrix(void){
	for(uint8_t clean=1;clean<=16;clean++){
		zeilen[clean][1]=0;
		zeilen[clean][2]=0;
	}
}

int main(){
	
	MCUCSR |= (1<<JTD);
	MCUCSR |= (1<<JTD);
	z=0;
	s=0;
	t=0;
	
	init_matrix();
	lock_matrix();
	uart_init();
	uart_string("ready.\n");
	o=0;
	sei();
	clean_matrix();
	while(1){
		print_matrix();
	}
	
	//never reached
	return(0);
}
